org.apache.lucene.index

## Class MultiDocsEnum

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.DocsEnum
    - - org.apache.lucene.index.MultiDocsEnum

-     public final class MultiDocsEnum
      extends DocsEnum

  Exposes `DocsEnum`, merged from `DocsEnum` API of sub-segments.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MultiDocsEnum.EnumWithSlice` Holds a `DocsEnum` along with the corresponding `ReaderSlice`.

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.DocsEnum

      `FLAG_FREQS, FLAG_NONE`

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiDocsEnum(MultiTermsEnum parent, int subReaderCount)` Sole constructor

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `boolean` | `canReuse(MultiTermsEnum parent)` Returns `true` if this instance can be reused by the provided `MultiTermsEnum`.
    `int` | `docID()` Returns the following: -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `int` | `freq()` Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`.
    `int` | `getNumSubs()` How many sub-readers we are merging.
    `MultiDocsEnum.EnumWithSlice[]` | `getSubs()` Returns sub-readers we are merging.
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.lucene.index.DocsEnum

      `attributes`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MultiDocsEnum

          public MultiDocsEnum(MultiTermsEnum parent,
                       int subReaderCount)

      Sole constructor
      Parameters:
        `parent` - The `MultiTermsEnum` that created us.
        `subReaderCount` - How many sub-readers are being merged.

  - ### Method Detail

    - #### canReuse

          public boolean canReuse(MultiTermsEnum parent)

      Returns `true` if this instance can be reused by the provided `MultiTermsEnum`.

    - #### getNumSubs

          public int getNumSubs()

      How many sub-readers we are merging.
      See Also:
        `getSubs()`

    - #### getSubs

          public MultiDocsEnum.EnumWithSlice[] getSubs()

      Returns sub-readers we are merging.

    - #### freq

          public int freq()
                   throws IOException

      Description copied from class: `DocsEnum`
      Returns term frequency in the current document, or 1 if the field was indexed with `FieldInfo.IndexOptions.DOCS_ONLY`. Do not call this before `DocIdSetIterator.nextDoc()` is first called, nor after `DocIdSetIterator.nextDoc()` returns `DocIdSetIterator.NO_MORE_DOCS`.

      NOTE: if the `DocsEnum` was obtain with `DocsEnum.FLAG_NONE`, the result of this method is undefined.

      Specified by:
        `freq` in class `DocsEnum`
      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - -1 or `DocIdSetIterator.NO_MORE_DOCS` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### advance

          public int advance(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.